<script setup lang="ts">
	import { onMounted, ref, watch } from 'vue'
	import { formatDate } from '../../utils/date';
	import { getAction } from '../../common/http';
	import { showToast } from 'vant';

	const form = ref({} as any)
	const show = ref(false)
	const list = ref([] as any[])
	const dataType = ref('')

	onMounted(() => {
		init()
		getAction('/fabric/info/all').then((res : any) => {
			if (res.code === 200) {
				res.data.forEach((l : any) => {
					let itemMl = mlList.value.find(m => m.text === l.commodity)
					if (itemMl) {
						let itemMm = itemMl.children.find(m => m.value === l.momme)
						if (itemMm) {
							itemMm.children.push({ text: l.width + 'cm', value: l.width })
						} else {
							itemMl.children.push({
								text: l.momme + 'mm',
								value: l.momme,
								children: [{ text: l.width + 'cm', value: l.width }]
							})
						}
					} else {
						mlList.value.push({
							text: l.commodity,
							value: l.commodity,
							children: [{ text: l.momme + 'mm', value: l.momme, children: [{ text: l.width + 'cm', value: l.width }] }]
						})
					}
				})
			}
		})
	})

	watch(form.value, () => {
		if (timer.value) {
			clearTimeout(timer.value)
		}
		timer.value = setTimeout(() => {
			currentPage.value = 1
			init()
			list.value=[]
		}, 1000)
	})

	const init = () => {
		let a = {}
		for (let i in form.value) {
			if (form.value[i]) {
				a[i] = form.value[i]
			}
		}
		let param = {
			page: currentPage.value,
			size: 20,
			...a
		}
		getAction('/rawFabricLog', param).then((res : any) => {
			if (res.code === 200) {
				res.data.record.forEach((l : any) => {
					list.value.push(l)
				})
				total.value = res.data.total
				loading.value = false;
				finished.value = false
			}
		})
	}

	const onClickLeft = () => {
		window.history.back()
	}
	
	const chooseDate = (val : any) => {
		show.value = true
		dataType.value = val
	}

	const onConfirmDate = (val : any) => {
		form.value[dataType.value] = formatDate(val)
		show.value = false
	}

	const total = ref(0)
	const currentPage = ref(1)
	const finished = ref(false)
	const loading = ref(false);

	//动态获取数据
	const onLoad = () => {
		if (list.value.length < total.value) {
			currentPage.value++
			init()
		} else {
			finished.value = true
		}
	};


	const pickerList = ref([])//面料数据
	const pickerContainerList = ref([])
	const showPickerList = ref(false)
	const searchValue = ref('')//查询的值
	const searchIndex = ref(0)//查询到的数组
	const mlList = ref([])
	//选择面料
	const selectChoose = () => {
		showPickerList.value = true
	}
	//面料开启
	const mlmcOpen = () => {
		pickerList.value = mlList.value
		pickerContainerList.value = pickerList.value
		searchValue.value = ''
	}
	//面料关闭
	const pickerCancel = () => {
		showPickerList.value = false
	}

	//搜索
	const selectedValue = ref()
	const getSeachList = () => {
		searchIndex.value = 0
		let reg = new RegExp(searchValue.value)
		let arr = []
		pickerList.value.forEach(l => {
			if (reg.test(l.text)) {
				arr.push(l)
			}
		})
		pickerContainerList.value = arr
	}
	//向上选择
	const upSearch = () => {
		if (searchIndex.value === 0 && pickerContainerList.value.length) {
			searchIndex.value = pickerContainerList.value.length - 1
			selectedValue.value = [pickerContainerList.value[searchIndex.value].text]
		} else if (pickerContainerList.value.length) {
			searchIndex.value--
			selectedValue.value = [pickerContainerList.value[searchIndex.value].text]
		} else {
			showToast('没有了！')
		}
	}
	//向下选择
	const downSearch = () => {
		if (pickerContainerList.value.length) {
			if (searchIndex.value === pickerContainerList.value.length) {
				searchIndex.value = 0
				selectedValue.value = [pickerContainerList.value[searchIndex.value].text]
			} else {
				searchIndex.value++
				selectedValue.value = [pickerContainerList.value[searchIndex.value].text]
			}
		} else {
			showToast('没有了！')
		}
	}
	//搜索框输入
	const timer = ref()
	const searchTo = () => {
		if (timer.value) {
			clearTimeout(timer.value)
		}
		timer.value = setTimeout(() => {
			getSeachList()
		}, 800)
	}
	const onConfirm = (val : any) => {
		form.value.fabricName = val.selectedValues[2] + '/' + val.selectedValues[0] + val.selectedValues[1]
		pickerCancel()
	}
</script>

<template>
	<view class="flex">
		<van-nav-bar title="白胚出入库记录" left-text="返回" left-arrow @click-left="onClickLeft"/>
		<van-cell-group style="display: flex;">
			<van-field v-model="form.startDate" name="开始时间" label="开始时间" colon class="bor" label-width="5em" readonly
				@click="chooseDate('startDate')" :rules="[{ required: true, message: '请填写' }]" />
			<van-field v-model="form.endDate" name="截止时间" label="截止时间" colon class="bor" label-width="5em" readonly
				@click="chooseDate('endDate')" />
		</van-cell-group>
		<van-cell-group style="display: flex;">
			<van-field v-model="form.fabricName" name="面料名称" label="面料名称" colon class="bor" label-width="5em" readonly
				@click="selectChoose" />
			<van-field v-model="form.barcode" name="面料编号" label="面料编号" colon class="bor-a" label-width="5em" />
		</van-cell-group>
		<van-cell-group style="display: flex;">
			<van-field v-model="form.len" name="面料米数" label="面料米数" colon class="bor-a" label-width="5em" />
			<van-field v-model="form.flow" name="面料位置" label="面料位置" colon class="bor-a" label-width="5em" />
		</van-cell-group>

		<view class="grid-container">
			<view class="grid-item">操作时间<br>操作人</view>
			<view class="grid-item">面料名称<br>面料编号</view>
			<view class="grid-item">操作米数</view>
			<view class="grid-item">操作<br>流向</view>
		</view>
		<view class="content">
			<van-list v-model:loading="loading" :finished="finished" finished-text="没有更多了" @load="onLoad">
				<view class="grid-container" v-for="(item,index) in list" :key="index" @click="toDetile(item)">
					<view class="grid-item">{{item.createTime}}<br>{{item.operator}}</view>
					<view class="grid-item">{{item.fabricName}}<br>{{item.barcode}}</view>
					<view class="grid-item" @click.stop="changeLen(item)">{{item.len}}</view>
					<view class="grid-item">{{item.action}}<br>{{item.flow}}</view>
				</view>
			</van-list>
		</view>
	</view>

	<!--    面料选择框-->
	<van-popup v-model:show="showPickerList" position="bottom" @open="mlmcOpen">
		<view class="select-model">
			<van-picker :columns="pickerContainerList" @cancel="pickerCancel" v-model="selectedValue"
				@confirm="onConfirm" />
			<view>
				<view class="top-select">
					<view class="confirm-select">
						<p>请选择品种</p>
					</view>
					<view class="search-box">
						<view>
							<van-search placeholder="请输入品种名字" v-model="searchValue" label="面料搜索：" background="#ffffff"
								@input="searchTo()" :clearable="false" />
						</view>
						<view class="flex-btn">
							<button class="search-btn" @click="upSearch()">↑</button>
							<button class="search-btn" @click="downSearch()">↓</button>
						</view>
					</view>
				</view>
			</view>
		</view>
	</van-popup>

	<van-calendar v-model:show="show" @confirm="onConfirmDate" :min-date="new Date(2010, 0, 1)"
		:max-date="new Date(2050, 0, 31)" />
</template>

<style scoped lang="scss">
	.flex {
		display: flex;
		flex-direction: column;
		height: 100vh;
		width: 100vw;
		overflow-y: hidden;

		.van-nav-bar {
			width: 100%;
		}
	}
	.content {
		flex: 1;
		overflow-y: scroll;
	}
	.grid-container {
		display: grid;
		grid-template-columns: 2fr 1.6fr 1.3fr 1.5fr;
		padding: 0 15rpx;
	
		.grid-item {
			border: 1rpx solid #f2f2f2;
			display: flex;
			align-items: center;
			justify-content: center;
			padding: 5rpx;
			text-align: center;
		}
	}

	::v-deep .van-cell {
		padding: 5px !important;
	}

	::v-deep .van-field {
		font-size: 16px;
	}

	.bor {
		::v-deep .van-field__control {
			border: 1px solid #d7d7d7;
			text-align: center;
		}

		::v-deep .van-field__label {
			margin: 0;
		}
	}

	.bor-a {
		::v-deep .van-field__control {
			border-bottom: 1px solid #d7d7d7;
			text-align: center;
		}

		::v-deep .van-field__label {
			margin: 0;
		}
	}

	::v-deep .van-button--normal {
		padding: 5px 8px;
		height: 30px;
	}

	::v-deep .van-field__control {
		text-align: center;
	}

	.footer-button {
		margin: 20px;
		display: flex;
		justify-content: space-around;
	}

	/*面料选择搜索框*/
	.select-model {
		position: relative;
	}

	.confirm-select {
		width: 100%;
	}

	.confirm-select>p {
		text-align: center;
	}

	.confirm-select>button {
		border: none;
		background-color: #ffffff;
		color: #388aed;
		margin: 10px 30px 0 0;
	}

	.top-select {
		position: absolute;
		top: 30px;
		left: 0;
		right: 0;
		margin: auto;
		z-index: 999;
	}

	::v-deep .select-model .van-picker__toolbar {
		height: 66px;
		align-items: flex-start;
		/*justify-content: flex-end;*/
	}

	::v-deep .select-model .van-picker__cancel,
	.select-model .van-picker__confirm {
		height: 30px;
		padding: 10px 16px 0;
	}
	::v-deep .select-model .van-picker__confirm,
	.select-model .van-picker__confirm {
		height: 30px;
		padding: 10px 16px 0;
	}

	.search-btn {
		padding: 1px 8px;
		border: none;
		background-color: #388aed;
		color: #ffffff;
		margin-left: 5px;
		height: 30px;
		line-height: 25px;
	}

	.search-box {
		display: flex;
		flex-direction: row;
		align-items: center;
		justify-content: center;
		padding-top: 15px;
		padding-bottom: 5px;
		position: relative;
		background-color: #fff;
	}

	.van-search {
		background-color: #f7f7f8;
	}

	.ml-search-jump {
		padding: 3px 10px;
		background-color: #388aed;
		color: #ffffff;
		border: none;
		margin-left: 10px;
	}

	.flex-btn {
		display: flex;
		flex-direction: row;
		align-items: center;
		justify-content: space-between;
	}
</style>